SystemOrganization addCategory: #ConfigurationOfProfStef!

Object subclass: #ConfigurationOfProfStef
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfProfStef'!

!ConfigurationOfProfStef commentStamp: '<historical>' prior: 0!
To load last stable version:
ConfigurationOfProfStef project latestVersion load.

To load a specific version (ex: version 1.6):
(ConfigurationOfProfStef project version: '1.6') load.

to do: 
	- should migrate shout and update the dependency.!

!ConfigurationOfProfStef class methodsFor: 'private' stamp: 'LaurentLaffont 1/21/2010 09:01'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfProfStef class methodsFor: 'private' stamp: 'LaurentLaffont 1/21/2010 09:01'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfProfStef class methodsFor: 'loading' stamp: 'LaurentLaffont 2/26/2012 14:29'!
load
	^(self project version: #stable) load! !

!ConfigurationOfProfStef class methodsFor: 'loading' stamp: 'LaurentLaffont 2/26/2012 14:29'!
loadDevelopment
	^(self project version: #development) load! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfProfStef class methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 09:01'!
project

	^self new project! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'DaleHenrichs 3/4/2010 10:30'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Core Tests' with: #('Core' 'Tests');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'LaurentLaffont 5/10/2010 22:16'!
baseline11: spec 
	<version: '1.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core Browser Tests');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Core Browser Tests' with: #('Core' 'Browser' 'Tests');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'LaurentLaffont 9/19/2010 16:44'!
baseline12: spec 
	<version: '1.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Help' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core' 'Browser' 'Tests' 'Help');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Help' with: #('ProfStef-Help');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'LaurentLaffont 11/22/2010 22:03'!
baseline15: spec 
	<version: '1.5-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Help' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core' 'Tests' 'Help');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Help' with: #('ProfStef-Help');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'TudorGirba 11/24/2010 00:00'!
baseline16: spec 
	<version: '1.6-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Help' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core' 'Tests' 'Help');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Help' with: #('ProfStef-Help');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'TudorGirba 3/11/2013 08:04'!
baseline17: spec 
	<version: '1.7-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'Migration to SmalltalkHub'.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/ProfStef/main'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'ProfStef-Core' with: [ spec requires: 'Shout' ];
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Help' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core' 'Tests' 'Help');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Help' with: #('ProfStef-Help');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'TudorGirba 3/11/2013 08:01'!
baseline18: spec 
	<version: '1.8-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'No Shout in Pharo 2.0'.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://smalltalkhub.com/mc/PharoExtras/ProfStef/main'.
		spec 
			package: 'ProfStef-Core';
			package: 'ProfStefBrowser' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Tests' with: [ spec requires: 'ProfStef-Core'];
			package: 'ProfStef-Help' with: [ spec requires: 'ProfStef-Core'].
			
		spec 
			group: 'default' with: #('Core' 'Tests' 'Help');
			group: 'Core' with: #('ProfStef-Core');
			group: 'Browser' with: #('ProfStefBrowser');
			group: 'Tests' with: #('ProfStef-Tests');
			group: 'Help' with: #('ProfStef-Help');
			yourself.
	]! !

!ConfigurationOfProfStef methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 09:01'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfProfStef methodsFor: 'symbolic versions' stamp: 'TudorGirba 3/11/2013 08:00'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'pharo1.0.x' version: '1.0'. 
	spec for: #'pharo1.1.x' version: '1.1'. 
	spec for: #'pharo1.2.x' version: '1.6'.
	spec for: #'pharo1.3.x' version: '1.9'.
	spec for: #'pharo1.4.x' version: '1.9'.
	spec for: #'pharo2.x' version: '1.10'.! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 2/1/2010 22:29'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: 'Release 1.0 of this project '.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.0';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.2';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.2'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'TudorGirba 3/11/2013 08:00'!
version110: spec
	<version: '1.10' imports: #('1.8-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Laurent Laffont'.
		spec description: 'Fix syntax highlighting'.
	].
	
	spec for: #pharo do: [		
		spec 
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.29';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.16';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.30';
			package: 'ProfStef-Help' with: 'ProfStef-Help-AlainPantec.7'.
	]
			
		! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 9/19/2010 16:45'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: 'Release 1.1 of this project '.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.0';
			package: 'ProfStef-Core' with: 'ProfStef-Core-DannyChan.10';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.8';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.26'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 9/19/2010 16:47'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: 'Release 1.2 -- Add SystemHelp'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.0';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.11';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.8';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.26';
			package: 'ProfStef-Help' with: 'ProfStef-Help-LaurentLaffont.1'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'jannikLaval 11/20/2010 08:46'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'AlexandreBergel'.
		spec description: 'Updated Shout'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.1.1';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.11';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.8';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.26';
			package: 'ProfStef-Help' with: 'ProfStef-Help-LaurentLaffont.1'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'jannikLaval 11/20/2010 08:45'!
version14: spec
	<version: '1.4' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'JannikLaval'.
		spec description: 'Updated Shout for Pharo 1.2'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.2.1';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.11';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.8';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.26';
			package: 'ProfStef-Help' with: 'ProfStef-Help-LaurentLaffont.1'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 11/22/2010 22:17'!
version15: spec
	<version: '1.5' imports: #('1.5-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: '- Updated ProfStef packages for Pharo 1.2. 
		                            - ProfStefBrowser removed from default
		                            - ProfStef-Help is now the default browser'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.2.1';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.14';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.9';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.29';
			package: 'ProfStef-Help' with: 'ProfStef-Help-LaurentLaffont.2'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 2/15/2011 22:54'!
version16: spec
	<version: '1.6' imports: #('1.6-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: '- Updated ProfStef packages for Pharo 1.2. 
		                            - ProfStefBrowser removed from default
		                            - ProfStef-Help is now the default browser
		                            - Add lessons on Reflection and Debugger in SmalltalkSyntaxTutorial'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.2.2';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.22';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.11';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.29';
			package: 'ProfStef-Help' with: 'ProfStef-Help-LaurentLaffont.3'.
	]
			! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'MarianoMartinezPeck 4/29/2011 20:06'!
version17: spec
	<version: '1.7' imports: #('1.6-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Mariano Martinez Peck'.
		spec description: '- Updated for Pharo 1.3'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.3';
			package: 'ProfStef-Core' with: 'ProfStef-Core-MarianoMartinezPeck.24';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-MarianoMartinezPeck.14';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.30';
			package: 'ProfStef-Help' with: 'ProfStef-Help-MarianoMartinezPeck.6'.
	]
			
		! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 9/18/2011 20:23'!
version18: spec
	<version: '1.8' imports: #('1.6-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Laurent Laffont'.
		spec description: '- Updated for Pharo 1.4'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.3';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.28';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.16';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.30';
			package: 'ProfStef-Help' with: 'ProfStef-Help-MarianoMartinezPeck.6'.
	]
			
		! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'TudorGirba 3/11/2013 07:59'!
version19: spec
	<version: '1.9' imports: #('1.7-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Laurent Laffont'.
		spec description: 'Fix syntax highlighting'.
	].
	
	spec for: #pharo do: [		
		spec 
			project: 'Shout' with: '1.3';
			package: 'ProfStef-Core' with: 'ProfStef-Core-LaurentLaffont.29';
			package: 'ProfStef-Tests' with: 'ProfStef-Tests-LaurentLaffont.16';
			package: 'ProfStefBrowser' with: 'ProfStefBrowser-LaurentLaffont.30';
			package: 'ProfStef-Help' with: 'ProfStef-Help-AlainPantec.7'.
	]
			
		! !
